/*
 * BlatAntLib.h
 *
 *  Created on: 20-dic-2010
 *      Author: attila
 */

#ifndef OVSWTEMPLATESAMPLELIB_H_
#define OVSWTEMPLATESAMPLELIB_H_

#include <omnetpp.h>
#include <InitStages.h>

#include <OverSwarm.h>
#include <OvSwBridgeUtils.h>

using namespace overswarm;

namespace oversim {

class OvSwTemplateSampleLib : public cSimpleModule {
public:
	OvSwTemplateSampleLib() {};
	virtual ~OvSwTemplateSampleLib() {};

	virtual void initialize(int stage);
	virtual void handleMessage(cMessage* msg)
	{
	    error("this module doesn't handle messages, it runs only in initialize()");
	};

	/* Exported services */

	OvSwValue::Ptr nodeId(void* owner, OvSwStack* st);
	OvSwValue::Ptr getRandomNodes(void* owner, OvSwStack* st);
	OvSwValue::Ptr say(void* owner, OvSwStack* st, OvSwValue::Ptr msg);

private:

	OvSwValue::Ptr id;

protected:

	OvSwValue::Ptr dummylist;
};

}


#endif /* OVSWTEMPLATESAMPLELIB_H_ */
