#ifndef __OVERSWARMTEMPLATE_H_
#define __OVERSWARMTEMPLATE_H_

#include <OverSwarm.h>
#include <BaseOverSwarmOverlay.h>

/* Overswarm generated headers go here*/
#include "OverSwarmTemplate_Headers.h"

/* Additional headers go here */
#include "OvSwTemplateSampleLib.h"

namespace oversim {

class OverSwarmTemplate : public overswarm::BaseOverSwarmOverlay
{
public:
	OverSwarmTemplate();
    virtual ~OverSwarmTemplate();

    virtual void initializeOverlay(int stage);
    virtual void handleTimerEvent(cMessage* msg);

	friend class OvSwTemplateSampleLib;

protected:

    // TODO

private:

    /* Method prototypes go here */
	#include "OverSwarmTemplate_MethodPrototypes.h"

    /* Other private fields and methods go here */
	OvSwTemplateSampleLib* utils;

    cMessage *internalTimer;

    bool isMaster;
};

}

#endif
